#!/usr/bin/perl

$base_x = calc_off("5mm");
$base_y = calc_off("5mm");

$geom_x = 0;
$geom_y = 0;
$geom_xsize = 0;
$geom_ysize = 0;

$xoff = 0;
$yoff = 0;
$last_doff = 0;
$do_rot = 0;

$head = "";
$dri_tab = "";
$dri = "";

$next = 0;
while ($#ARGV >= 0) {
	$arg = @ARGV[0];
	shift @ARGV;
	if ($arg =~ m/^-x/) {
		$next = 1;	
	} elsif ($arg =~ m/^-y/) {
		$next = 2;	
	} elsif ($arg =~ m/^-r/) {
		$do_rot = 1;
	} elsif ($arg =~ m/^-g/) {
		$next = 10;
	} else {
		if ($next == 1) {
			$xoff = calc_off($arg);
			$next = 0;
#printf("xoff = %d\n",$xoff);
		} elsif ($next == 2) {
			$yoff = calc_off($arg);
			$next = 0;
#printf("yoff = %d\n",$yoff);
		} elsif ($next == 10) {
			$geom_x = calc_off($arg);
			$next = 11;
		} elsif ($next == 11) {
			$geom_y = calc_off($arg);
			$next = 12;
		} elsif ($next == 12) {
			$geom_xsize = calc_off($arg);
			$next = 13;
		} elsif ($next == 13) {
			$geom_ysize = calc_off($arg);
			$next = 0;
		} else {
#printf("start func $s %d %d",$arg,$xoff,$yoff);
			do gerbconv($arg);
			$xoff = 0;
			$yoff = 0;
			$do_rot = 0;
			$geom_x = 0;
			$geom_y = 0;
			$geom_xsize = 0;
			$geom_ysize = 0;
			$next = 0;
		}
	}
}
print $head;
printf("%%\r\n");
print $dri_tab;
printf("%%\r\n");
print $dri;
printf("M30\r\n");

sub calc_off {
    my($in,$off);
    $in = @_[0];
    $in =~ m/^(-*[0-9]+|-*[0-9]*\.[0-9]*)(|mm|in)$/;
    $off = $1;
    if ($2 =~ /^mm/) {
	    $off = $off * 10000 / 25.4;
    } elsif ($2 =~ /^in/) {
	    $off = $off * 10000;
    } else { # default inch
	    $off = $off * 10000;
    }
    return $off;
}

sub gerbconv {
    my($fn,$doff,$doff_cur);
    $doff = -1;
    $doff_cur = 0;
    $fn = @_[0];
    $head = "";

#printf("fn = %s\n",$fn);
    open(FILE,"$fn") || die;

    while (<FILE>) {
	chop;
	chop if (/\r$/);
	if (/^M30/) {
	} elsif (/^%$/) {
	} elsif (/^T([0-9]+)C([0-9]*\.[0-9]*)$/) {
		$d = $1;
		if ($doff == -1) {
			$doff_cur = $d;
			$doff = $last_doff + 1 - $d;
		}
		$size = $2;
		$d += $doff;
		if ($d > $last_doff) {
			$last_doff = $d;
		}
		$s = sprintf("T%02dC%s\r\n",$d,$size);
		$dri_tab = $dri_tab.$s;
	} elsif (/^T([0-9]+)$/) {
		$d = $1;
		$d += $doff;
		$s = sprintf("T%02d\r\n",$d);
		$dri = $dri.$s;
	}elsif (/^X([0-9]+)Y([0-9]+)$/) {
		if ($do_rot) {
			$x = $2 - $geom_y;
			$y = -$1 + $geom_x + $geom_xsize;
		} else {
			$x = $1 - $geom_x;
			$y = $2 - $geom_y;
		}
		$x += $base_x;
		$y += $base_y;
		$x += $xoff;
		$y += $yoff;
		$d += $doff;
		$s = sprintf("X%dY%d\r\n",$x,$y);
		$dri = $dri.$s;
	} else {
		$s = sprintf("%s\r\n",$_);
		$head = $head.$s;
	}
    }
    close(FILE);
}
